/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett	       - initial API and implementation
 *     Michael Fiedler     - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse
 *     .org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.aide.oslc.ccm;

import java.net.URI;
import java.util.Date;
import java.util.HashSet;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

// Start of user code imports
// End of user code

@OslcNamespace(ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE)
@OslcName(ConfigurationManagementConstants.VERSIONRESOURCE)
@OslcResourceShape(title = "VersionResource Resource Shape",
                   describes = ConfigurationManagementConstants.TYPE_VERSIONRESOURCE)
public interface IVersionResource {

  public void addCommitter(final Link committer);

  public void addComponent(final String component);

  public void addWasDerivedFrom(final Link wasDerivedFrom);

  public void addWasRevisionOf(final Link wasRevisionOf);

  @OslcName("contributor")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "contributor")
  @OslcDescription(
      "Contributor or contributors to the resource. It is likely that the target resource will " +
          "be" + " a foaf:Person but that is not necessarily the case.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcRange({ConfigurationManagementConstants.TYPE_PERSON})
  @OslcReadOnly(false)
  public Link getContributor();

  public void setContributor(final Link contributor);

  @OslcName("created")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "created")
  @OslcDescription("Timestamp of resource creation")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.DateTime)
  @OslcReadOnly(false)
  public Date getCreated();

  public void setCreated(final Date created);

  @OslcName("creator")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "creator")
  @OslcDescription(
      "Creator or creators of the resource. It is likely that the target resource will be a " +
          "foaf:Person but that is not necessarily the case.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcRange({ConfigurationManagementConstants.TYPE_PERSON})
  @OslcReadOnly(false)
  public Link getCreator();

  public void setCreator(final Link creator);

  @OslcName("description")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "description")
  @OslcDescription(
      "Descriptive text about resource represented as rich text in XHTML content. SHOULD include " +
          "" + "only content that is valid and suitable inside an XHTML <div> element.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.XMLLiteral)
  @OslcReadOnly(false)
  public String getDescription();

  public void setDescription(final String description);

  @OslcName("identifier")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "identifier")
  @OslcDescription(
      "A unique identifier for a resource. Typically read-only and assigned by the service " +
          "provider when a resource is created. Not typically intended for end-user display.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  public String getIdentifier();

  public void setIdentifier(final String identifier);

  @OslcName("isVersionOf")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "isVersionOf")
  @OslcDescription(
      "The concept resource of which this resource is a version. The subject of this property " +
          "must be the version resource URI.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcRepresentation(Representation.Reference)
  @OslcReadOnly(false)
  public Link getIsVersionOf();

  public void setIsVersionOf(final Link isVersionOf);

  @OslcName("modified")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "modified")
  @OslcDescription("Timestamp of latest resource modification")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.DateTime)
  @OslcReadOnly(false)
  public Date getModified();

  public void setModified(final Date modified);

  @OslcName("subject")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "subject")
  @OslcDescription(
      "Tag or keyword for a resource. Each occurrence of a dcterms:subject property denotes an "
          + "additional tag for the resource.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  @OslcTitle("")
  public String getSubject();

  public void setSubject(final String subject);

  @OslcName("title")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "title")
  @OslcDescription(
      "Title of the resource represented as rich text in XHTML content. SHOULD include only " +
          "content that is valid inside an XHTML <span> element.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.XMLLiteral)
  @OslcReadOnly(false)
  public String getTitle();

  public void setTitle(final String title);

  @OslcName("committed")
  @OslcPropertyDefinition(
      ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE + "committed")
  @OslcDescription(
      "Date and time this version resource was checked in. Absent for mutable (checked out) " +
          "versions.")
  @OslcOccurs(Occurs.ZeroOrOne)
  @OslcValueType(ValueType.DateTime)
  @OslcReadOnly(false)
  public Date getCommitted();

  public void setCommitted(final Date committed);

  @OslcName("committer")
  @OslcPropertyDefinition(
      ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE + "committer")
  @OslcDescription("The entity that checked in this version.")
  @OslcOccurs(Occurs.ZeroOrMany)
  @OslcValueType(ValueType.Resource)
  @OslcReadOnly(true)
  public HashSet<Link> getCommitter();

  public void setCommitter(final HashSet<Link> committer);

  @OslcName("component")
  @OslcPropertyDefinition(
      ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE + "component")
  @OslcDescription(
      "The component to which this version belongs. Configuration Management provider should " +
          "indicate the owning component for each version resource using either this property, " +
          "or" + " using the membership relationship from the component LDPC.")
  @OslcOccurs(Occurs.ZeroOrMany)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  public HashSet<String> getComponent();

  public void setComponent(final HashSet<String> component);

  @OslcName("versionId")
  @OslcPropertyDefinition(
      ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE + "versionId")
  @OslcDescription(
      "A short human-readable identifier for the version of a resource. All versioned resources "
          + "should have this property; where the property is present, this identifier must be "
          + "unique amongst all currently existing versions of the same concept resource. The " +
          "subject of this property should be the concept resource URI.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  public String getVersionId();

  public void setVersionId(final String versionId);

  @OslcName("instanceShape")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "instanceShape")
  @OslcDescription(
      "The URI of a Resource Shape that describes the possible properties, occurrence, value " +
          "types, allowed values and labels. This shape information is useful in displaying the "
          + "subject resource as well as guiding clients in performing modifications. Instance "
          + "shapes may be specific to the authenticated user associated with the request that "
          + "retrieved the resource, the current state of the resource and other factors and thus" +
          " " + "should not be cached.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcReadOnly(false)
  public URI getInstanceShape();

  public void setInstanceShape(final URI instanceShape);

  @OslcName("modifiedBy")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "modifiedBy")
  @OslcDescription(
      "The URI of a resource describing the entity that most recently modified the subject " +
          "resource. The link target is usually a foaf:Person or foaf:Agent, but could be any " +
          "type. This is modeled after dcterms:creator, but Dublin Core currently has no " +
          "equivalent property.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcReadOnly(false)
  public Link getModifiedBy();

  public void setModifiedBy(final Link modifiedBy);

  @OslcName("serviceProvider")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "serviceProvider")
  @OslcDescription(
      "A link to the resource's OSLC Service Provider. There may be cases when the subject " +
          "resource is available from a service provider that implements multiple domain " +
          "specifications, which could result in multiple values for this property.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcReadOnly(false)
  public URI getServiceProvider();

  public void setServiceProvider(final URI serviceProvider);

  @OslcName("shortId")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "shortId")
  @OslcDescription("Shorter form of dcterms:identifier for the resource, such as a number.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  public String getShortId();

  public void setShortId(final String shortId);

  @OslcName("shortTitle")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "shortTitle")
  @OslcDescription(
      "Shorter form of dcterms:title for the resource represented as rich text in XHTML content. " +
          "" + "SHOULD include only content that is valid inside an XHTML <span> element.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.XMLLiteral)
  @OslcReadOnly(false)
  public String getShortTitle();

  public void setShortTitle(final String shortTitle);

  @OslcName("type")
  @OslcPropertyDefinition(ConfigurationManagementConstants.RDF_NAMSPACE + "type")
  @OslcDescription("The resource type URIs")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcReadOnly(false)
  public Link getType();

  public void setType(final Link type);

  @OslcName("wasDerivedFrom")
  @OslcPropertyDefinition(ConfigurationManagementConstants.PROVENANCE_NAMSPACE + "wasDerivedFrom")
  @OslcDescription(
      "A resource from which this version was derived. This is likely to reference a different "
          + "concept resource; use of prov:wasRevisionOf is recommended to indicate an earlier "
          + "version of the same concept resource. The subject of each instance of this property " +
          "" + "must be the concept resource URI; the object can be a version resource URI, or a " +
          "" + "concept resource URI (possibly for a non-versioned resource).")
  @OslcOccurs(Occurs.ZeroOrMany)
  @OslcValueType(ValueType.Resource)
  @OslcRepresentation(Representation.Reference)
  @OslcReadOnly(false)
  public HashSet<Link> getWasDerivedFrom();

  public void setWasDerivedFrom(final HashSet<Link> wasDerivedFrom);

  @OslcName("wasRevisionOf")
  @OslcPropertyDefinition(ConfigurationManagementConstants.PROVENANCE_NAMSPACE + "wasRevisionOf")
  @OslcDescription(
      "A resource from which this version was derived. This is likely to reference an earlier " +
          "version of the same concept resource; use of prov:wasDerivedFrom is recommended to " +
          "indicate an earlier version of a different concept resource. The subject of each " +
          "instance of this property must be the concept resource URI; the object is likely to " +
          "be" + " a version resource URI.")
  @OslcOccurs(Occurs.ZeroOrMany)
  @OslcValueType(ValueType.Resource)
  @OslcRepresentation(Representation.Reference)
  @OslcReadOnly(false)
  public HashSet<Link> getWasRevisionOf();

  public void setWasRevisionOf(final HashSet<Link> wasRevisionOf);
}

